clear all;
close all;
clc;

load('CoPDataOncilla');


% currentTime = toc;
% newSample = [currentTime, ...                                       %TIME
%     q', GLOBAL_CONTROL_DATA.oncillaPosRad', ... %ONCILLA cmds & state
%     GLOBAL_CONTROL_DATA.centerOfPressureOld', ...                   %True Center of Pressure
%     GLOBAL_CONTROL_DATA.centerOfPressureOncilla'];                  %Estimated Center of Pressure
% GLOBAL_DATA_BUFFER = [GLOBAL_DATA_BUFFER; newSample];
%tmp = tmp(1000:10:end,:);
ids = randperm(size(tmp,1)-1000);

tmp = tmp(1000+ids(1:3:end),:);
 
time = tmp(:,1);

%Desired joint angles (motor commands)
cmds = tmp(:,2:13);
vels = diff(cmds); vels = [vels; vels(end,:)];
accs = diff(vels); accs = [accs; accs(end,:)];
 

%Joint encoder (motor) Oncilla
oncillaPosRad = tmp(:,14:14+12-1);

%Velocities joint encoder (motor) Oncilla
oncillaVel = tmp(:,14+12:14+12+12-1);

%true center of pressure
copTrue = tmp(:, 14+12+12:14+12+12+2-1);

%oncilla center of pressure (opto force estimate assuming oncilla fwd kinematics)
copOncilla = tmp(:, 14+12+12+2:14+12+12+2+2-1);


idsAll = randperm(size(tmp,1));
NTrain = round(0.95*size(tmp,1));
idsTrain = idsAll(1:NTrain);
idsTest = idsAll(NTrain+1:end);

X = [oncillaPosRad(:,[2,4]), oncillaVel(:,[2,4])];
% X = [oncillaPosRad(:,:), oncillaVel(:,:)];


Y = copTrue;%(:,2);

X_train = double(X(idsTrain,:));
Y_train = double(Y(idsTrain,:));
X_test = double(X(idsTest,:));
Y_test = double(Y(idsTest,:));
 
save('CoPDataOncillaGP.mat', 'X_train', 'Y_train', 'X_test', 'Y_test');

figure;
plot(X_train)

if 1==0

    lw =3;

    figure;
    plot(cmds);
    legend('motor commands');

    figure;
    plot(time, copTrue(:,2),'k', 'linewidth', lw); 
    hold on; 
    plot(time, copOncilla(:,2),'r--', 'linewidth', lw); 
    legend('true cop(y)', 'est cop(y)');

    cmdIds = [1,3,5,7];
    figure;
    for i=1:4
    subplot(1,4,i);
    plot(copTrue(:,1), oncillaPosRad(:,cmdIds(i)),'.k', 'linewidth', lw); 
    hold on;
    plot(copOncilla(:,1), oncillaPosRad(:,cmdIds(i)),'.r', 'linewidth', lw);

    %axis equal;
    legend(['true cop(y) vs. motor cmd ' num2str(cmdIds(i))], ...
        ['oncilla cop(y) vs. motor cmd ' num2str(cmdIds(i))]);

    end

    idsVelIsPositive = find(oncillaVel(:,2)>=0);
    idsVelIsNegative = setdiff(1:size(oncillaVel,1),idsVelIsPositive);

    %LEFT Right
    figure;
    plot(oncillaPosRad(:,2), copTrue(:,2),'.'); 
    xlabel('LF knee [rad]');
    ylabel('CoP M/L axis');
    legend('bend to the left');

    figure;
    plot(oncillaPosRad(:,2), copTrue(:,1),'.'); 
    xlabel('LF knee [rad]');
    ylabel('CoP anterior axis');
    legend('bend to the left');

    figure;
    plot(oncillaPosRad(idsVelIsPositive,2), copTrue(idsVelIsPositive,2), '.r');
    hold on;
    plot(oncillaPosRad(idsVelIsNegative,2), copTrue(idsVelIsNegative,2), '.b');

    xlabel('LF knee [rad]');
    ylabel('CoP M/L axis');
    legend('vel >= 0', 'vel < 0');

    figure;
    plot(oncillaVel(:,2), copTrue(:,2),'.');

end
