clear all;
close all;
clc;

%test lwr model
% load([pwd filesep 'Data' filesep 'CoPDataOncillaGP']);
load([pwd filesep 'Data' filesep 'FData4LinkGP']);

lwrModel = LWRModel(X_train, Y_train, 0.1, 0);

numInputDimensions = size(X_train,2);
numPredictors = size(Y_train,2);
if numPredictors > 1
    poolobj = gcp('nocreate'); % If no pool, do not create new one.
    if isempty(poolobj)
        parpool(numPredictors);
    end
end

numSamples = size(X_test,1);

estimate = nan(1,numPredictors);
copEst  = [];
copTrue = [];
err=nan(numSamples,1);
timePerSample =[];
id=1;


for i=1:numSamples 
    
    queryPoint = X_test(i,:);
    true = Y_test(i,:);
    copTrue = [copTrue; true];
    tic
    estimate = lwrModel.predict(queryPoint);
    timePerSample(id)=toc; 
    copEst = [copEst;estimate];
    err(id, :) = sqrt(mse(true-estimate));
    id=id+1;
end 
err = err(1:id-1,:);

figure;
hold all;
plot(copTrue(:,2));
plot(copEst(:,2));
legend('true', 'estimate');
% 
figure;
stem(err)
title('error')

mean(err)

% e = err(isfinite(err), :);
% mean(e)
% sum(isnan(err))
% length(err)
% % 
figure;
stem(timePerSample)
title('time')
